<?xml version="1.0" encoding="UTF-8" ?>
<!--
 #  The Contents of this file are made available subject to the terms of
 #  GNU Lesser General Public License Version 2.1
 #
 #  The Initial Developer of the Original Code is :
 #  BOBICIEL INFORMATIQUE - FRANCE, September 2003
 #
 #  Contributor(s):
 #  Robert DARGAUD  BOBICIEL INFORMATIQUE
 #  _______________ ______________________________
 #  _______________ ______________________________
 #  _______________ ______________________________
 #  _______________ ______________________________
 #
 #
 #  GNU Lesser General Public License Version 2.1
 #  =============================================
 #
 #  This library is free software; you can redistribute it and/or
 #  modify it under the terms of the GNU Lesser General Public
 #  License version 2.1, as published by the Free Software Foundation.
 #
 #  This library is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 #  Lesser General Public License for more details.
 #
 #  You should have received a copy of the GNU Lesser General Public
 #  License along with this library; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 #  MA  02111-1307  USA
 #
 #  =============================================
  -->

<!-- Product name : MaXForms OOo -->
<!-- Version      : 1.1.5 -->
<!-- Date         : july 2004 -->

<!-- to download new version : www.MaXOpenInfo.org, www.MaXOpenInfo.com or www.bobiciel.com -->

<!--
 -->

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:office="http://openoffice.org/2000/office" xmlns:style="http://openoffice.org/2000/style" xmlns:text="http://openoffice.org/2000/text" xmlns:table="http://openoffice.org/2000/table" xmlns:draw="http://openoffice.org/2000/drawing" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:meta="http://openoffice.org/2000/meta" xmlns:number="http://openoffice.org/2000/datastyle" xmlns:svg="http://www.w3.org/2000/svg" xmlns:chart="http://openoffice.org/2000/chart" xmlns:dr3d="http://openoffice.org/2000/dr3d" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:form="http://openoffice.org/2000/form" xmlns:script="http://openoffice.org/2000/script" xmlns:config="http://openoffice.org/2001/config"
 xmlns:data="http://www.maxopeninfo.org/xmlns/spip/data" xmlns:ext="http://www.maxopeninfo.org/xmlns/spip/ext" xmlns:lien="http://www.maxopeninfo.org/xmlns/spip/lien"
 office:class="text" office:version="1.0"
 exclude-result-prefixes="office meta  table number dc fo xlink chart math script xsl draw svg dr3d form config text style">

	<xsl:decimal-format name="staff" digit="D" />
	<xsl:output method="xml" indent="yes" omit-xml-declaration="no"/>

	<xsl:key name="controlForId" match="//office:forms/form:form//form:control" use="@form:id" />

	<xsl:key name="StyleForStyleName" match="//office:styles/style:style | //office:automatic-styles/style:style" use="@style:name" />
	<xsl:key name="ListStyleForStyleName" match="//office:styles/text:list-style | //office:automatic-styles/text:list-style" use="@style:name" />
	<xsl:key name="isBoldCaracteresForStyleName" match="//office:styles/style:style[style:properties/@fo:font-weight='bold'] | //office:automatic-styles/style:style[style:properties/@fo:font-weight='bold']" use="@style:name" />
	<xsl:key name="isItalicCaracteresForStyleName" match="//office:styles/style:style[style:properties/@fo:font-style='italic'] | //office:automatic-styles/style:style[style:properties/@fo:font-style='italic']" use="@style:name" />

	<!--  -->
	<!--
	-->
	<xsl:template match="/">

		<!-- DOCTYPE -->
		<xsl:value-of disable-output-escaping="yes" select="//office:body/text:section[starts-with(@text:name, '&lt;!DOCTYPE ')][1]/@text:name"/>
        <xsl:text>&#10;</xsl:text>

    	<xsl:choose>
        	<xsl:when test="count(//office:body/text:section[starts-with(@text:name, '&lt;xml:')])!=1">
                <maxforms>
                    <xsl:apply-templates select="//office:body/text:section"/>
                </maxforms>
            </xsl:when>
            <xsl:otherwise>
	            <xsl:apply-templates select="//office:body/text:section"/>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>

    <!-- les modeles ne sont pas exportes -->
  	<xsl:template match="text:section[@text:name='maxforms:templates']">
	</xsl:template>

  	<xsl:template match="text:section" priority="-1">
<!-- RMQ: blinder le nom de l'element -->
		<xsl:variable name="elementName" select="translate(substring-before(concat(substring-after(@text:name, '&lt;xml:'), '&gt;'), '&gt;'), ' ', '_')"/>
        <xsl:choose>
        	<xsl:when test="$elementName!=''" >
                <xsl:element name="{$elementName}">
                    <xsl:call-template name="FormControlsWithXmlAttributName"/>
                    <xsl:call-template name="FormControlsWithXmlElementName"/>
                    <xsl:apply-templates select=".//text:section[generate-id(ancestor::text:section[1])=generate-id(current())]"/>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
				<xsl:call-template name="FormControlsWithXmlAttributName"/>
				<xsl:call-template name="FormControlsWithXmlElementName"/>
	    		<xsl:apply-templates select=".//text:section[generate-id(ancestor::text:section[1])=generate-id(current())]"/>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>

	<xsl:template name="FormControlsWithXmlAttributName">

        <!-- one xml attribute by xml control xml:attrName -->
        <xsl:for-each select=".//draw:control[key('controlForId', @form:id)[starts-with(@form:name, 'xml:')] and (generate-id(ancestor::text:section[1])=generate-id(current()))]">
            <xsl:variable name="theControl" select="key('controlForId', @form:id)[1]"></xsl:variable>

            <xsl:for-each select="$theControl">
                  <xsl:choose>
                      <!-- ComboBox -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.ComboBox'">
<!-- RMQ: blinder le nom de l'attribut -->
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:combobox/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- ListBox -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.ListBox'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:for-each select="form:listbox/form:option[@form:current-selected='true']" >
                                  <xsl:if test="position()&gt;1">
                                      <xsl:text>;</xsl:text>
                                  </xsl:if>
                                  <xsl:value-of select="@form:label"/>
                              </xsl:for-each>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- TextField -->
                      <xsl:when test="(@form:service-name='com.sun.star.form.component.TextField')">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <!-- Modif RD : 27/04/2004 si la valeur par defaut est initialisee avec une chaine de caracteres '_', ce cacarctere est retire lors de l'export -->
                              <xsl:choose>
                                  <xsl:when test="translate(form:text/@form:value, '_', '')!=''">
                                      <xsl:choose>
                                          <xsl:when test="form:text">
                                              <xsl:value-of select="form:text/@form:current-value"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                              <xsl:value-of select="form:textarea/@form:current-value"/>
                                          </xsl:otherwise>
                                      </xsl:choose>
                                  </xsl:when>
                                  <xsl:otherwise>
                                      <xsl:choose>
                                          <xsl:when test="form:text">
                                              <xsl:value-of select="translate(form:text/@form:current-value, '_', '')"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                              <xsl:value-of select="translate(form:textarea/@form:current-value, '_', '')"/>
                                          </xsl:otherwise>
                                      </xsl:choose>
                                  </xsl:otherwise>
                              </xsl:choose>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- CurrencyField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.CurrencyField'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- DateField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.DateField'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- TimeField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.TimeField'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- FileControl -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.FileControl'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:file/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- FormattedField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.FormattedField'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- NumericField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.NumericField'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- PatternField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.PatternField'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- RadioButton -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.RadioButton'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:radio/@form:current-selected"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- CheckBox -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.CheckBox'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:checkbox/@form:current-state = 'checked'"/>
                          </xsl:attribute>
                      </xsl:when>
                      <!-- ImageControl -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.DatabaseImageControl'">
                          <xsl:attribute name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '['), '['), ' ', '_')}">
                              <xsl:value-of select="form:image-frame/@form:image-data"/>
                          </xsl:attribute>
                      </xsl:when>
                  </xsl:choose>
            </xsl:for-each>

        </xsl:for-each>

	</xsl:template>

	<xsl:template name="FormControlsWithXmlElementName">
        <!-- one xml element by xml control <xml:elementName> -->
        <xsl:for-each select=".//draw:control[key('controlForId', @form:id)[starts-with(@form:name, '&lt;xml:')] and (generate-id(ancestor::text:section[1])=generate-id(current()))]">
            <xsl:variable name="theControl" select="key('controlForId', @form:id)[1]"></xsl:variable>

            <xsl:for-each select="$theControl">
                  <xsl:choose>
                      <!-- ComboBox -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.ComboBox'">
<!-- RMQ: blinder le nom de l'element -->
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:combobox/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- ListBox -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.ListBox'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:for-each select="form:listbox/form:option[@form:current-selected='true']" >
                                  <xsl:if test="position()&gt;1">
                                      <xsl:text>;</xsl:text>
                                  </xsl:if>
                                  <xsl:value-of select="@form:label"/>
                              </xsl:for-each>
                          </xsl:element>
                      </xsl:when>
                      <!-- TextField -->
                      <xsl:when test="(@form:service-name='com.sun.star.form.component.TextField')">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <!-- Modif RD : 27/04/2004 si la valeur par defaut est initialisee avec une chaine de caracteres '_', ce cacarctere est retire lors de l'export -->
                              <xsl:choose>
                                  <xsl:when test="translate(form:text/@form:value, '_', '')!=''">
                                      <xsl:choose>
                                          <xsl:when test="form:text">
                                              <xsl:value-of select="form:text/@form:current-value"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                              <xsl:value-of select="form:textarea/@form:current-value"/>
                                          </xsl:otherwise>
                                      </xsl:choose>
                                  </xsl:when>
                                  <xsl:otherwise>
                                      <xsl:choose>
                                          <xsl:when test="form:text">
                                              <xsl:value-of select="translate(form:text/@form:current-value, '_', '')"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                              <xsl:value-of select="translate(form:textarea/@form:current-value, '_', '')"/>
                                          </xsl:otherwise>
                                      </xsl:choose>
                                  </xsl:otherwise>
                              </xsl:choose>
                          </xsl:element>
                      </xsl:when>
                      <!-- CurrencyField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.CurrencyField'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- DateField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.DateField'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- TimeField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.TimeField'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- FileControl -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.FileControl'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:file/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- FormattedField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.FormattedField'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- NumericField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.NumericField'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- PatternField -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.PatternField'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:formatted-text/@form:current-value"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- RadioButton -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.RadioButton'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:radio/@form:current-selected"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- CheckBox -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.CheckBox'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:checkbox/@form:current-state = 'checked'"/>
                          </xsl:element>
                      </xsl:when>
                      <!-- ImageControl -->
                      <xsl:when test="@form:service-name='com.sun.star.form.component.DatabaseImageControl'">
                          <xsl:element name="{translate(substring-before(concat(substring-after(@form:name, 'xml:'), '&gt;'), '&gt;'), ' ', '_')}">
                              <xsl:value-of select="form:image-frame/@form:image-data"/>
                          </xsl:element>
                      </xsl:when>

                  </xsl:choose>
            </xsl:for-each>

        </xsl:for-each>

	</xsl:template>

    <!-- Section texte ne comportant ni Controle de formulaire, ni section imbriquee -->
  	<xsl:template match="text:section[starts-with(@text:name, '&lt;xml:') and count(.//draw:control)=0 and count(.//text:section)=0]">

<!-- RMQ: blinder le nom de l'element -->
		<xsl:variable name="elementName" select="translate(substring-before(concat(substring-after(@text:name, '&lt;xml:'), '&gt;'), '&gt;'), ' ', '_')"/>
        <!-- le contenu de la section est exporte sous forme de "texte enrichi" et selon le (ou les) filtre(s) selectionne(s) -->
        <xsl:if test="contains(substring-after(@text:name, '&gt;'), '|spip')">
	        <xsl:element name="{$elementName}">
<!-- RMQ: revoir eventuellement le nom de cet attribut (type ?)-->
    	        <xsl:attribute name="mode">spip</xsl:attribute>
        	    <xsl:apply-templates select="child::*" mode="spip"/>
	        </xsl:element>
        </xsl:if>
<!-- RMQ: a terminer -->
        <!-- xsl:if test="contains(substring-after(@text:name, '&gt;'), '|html')">
	        <xsl:element name="{$elementName}">
	            <xsl:attribute name="mode">html</xsl:attribute>
    	        <xsl:apply-templates select="child::*" mode="html"/>
	        </xsl:element>
        </xsl:if -->
        <!-- xsl:if test="contains(substring-after(@text:name, '&gt;'), '|text')">
	        <xsl:element name="{$elementName}">
        	    <xsl:attribute name="mode">text</xsl:attribute>
            	<xsl:apply-templates select="child::*" mode="text"/>
	        </xsl:element>
        </xsl:if -->
        <!-- xsl:if test="contains(substring-after(@text:name, '&gt;'), '|rtf')">
	        <xsl:element name="{$elementName}">
        	    <xsl:attribute name="mode">rtf</xsl:attribute>
            	<xsl:apply-templates select="child::*" mode="rtf"/>
	        </xsl:element>
        </xsl:if -->
        <xsl:if test="not(contains(substring-after(@text:name, '&gt;'), '|')) or contains(substring-after(@text:name, '&gt;'), '|xml')">
	        <xsl:element name="{$elementName}">
	            <xsl:attribute name="mode">xml</xsl:attribute>
    	        <xsl:apply-templates select="child::*" mode="xml"/>
	        </xsl:element>
        </xsl:if>

	</xsl:template>

    <!-- Section texte contenant de l'XML BRUT a inserer dans le resultat -->
  	<xsl:template match="text:section[starts-with(text:p[1], '&lt;?xml ')]">
        <xsl:apply-templates select="child::node()" mode="xmlbrut"/>
	</xsl:template>

  	<xsl:template match="child::*" mode="xmlbrut">
        <xsl:apply-templates select="child::node()" mode="xmlbrut"/>
	</xsl:template>

  	<xsl:template match="text:p[1]/text()" mode="xmlbrut">
	</xsl:template>

  	<xsl:template match="text:p/text() | text:h/text() | text:span/text()" mode="xmlbrut" priority="-1">
    	<xsl:value-of disable-output-escaping="yes" select="."/>
	</xsl:template>

  	<xsl:template match="text()" mode="xmlbrut" priority="-2">
    	<xsl:value-of select="."/>
	</xsl:template>

    <!-- Section "texte enrichi",  export en mode 'xml' -->
    <!-- Paragraphe -->
  	<xsl:template match="text:p | text:h" mode="xml">
    	<xsl:apply-templates select="child::node()" mode="xml"/>
        <!-- Si l'on est pas dans une cellule de table, on ajoute un saut a la ligne -->
        <xsl:if test="name(..)!='table:table-cell'">
	        <xsl:text>&#10;</xsl:text>
        </xsl:if>
	</xsl:template>

  	<xsl:template match="text:p/text() | text:h/text() | text:s/text() | text:span/text() | text:a/text()" mode="xml">
    	<xsl:value-of select="."/>
	</xsl:template>

    <!-- Table -->
  	<!-- xsl:template match="table:table" mode="xml">
        <xsl:text></xsl:text>
    	<xsl:apply-templates select="child::*" mode="xml"/>
	</xsl:template>
  	<xsl:template match="table:table-column" mode="xml">
        <xsl:text></xsl:text>
    	<xsl:apply-templates select="child::*" mode="xml"/>
	</xsl:template>
  	<xsl:template match="table:table-header-rows" mode="xml">
        <xsl:text></xsl:text>
    	<xsl:apply-templates select="child::*" mode="xml"/>
	</xsl:template -->
  	<xsl:template match="table:table/table:table-row" mode="xml">
        <xsl:element name="{translate(../@table:name,'ABCDEFGHIJKLMNOPQRSTUWVXYZ ','abcdefghijklmnopqrstuwvxyz_')}">
	    	<xsl:apply-templates select="child::*" mode="xml"/>
        </xsl:element>
	</xsl:template>

  	<xsl:template match="table:table/table:table-header-rows/table:table-row/table:table-cell" mode="xml">
        <xsl:text></xsl:text>
	</xsl:template>

  	<xsl:template match="table:table/table:table-row/table:table-cell" mode="xml">
		<!-- si une entete existe, les noms d'attributs sont construits a partir du contenu de la premiere ligne d'entete de la table -->
       	<xsl:variable name="attrPos" select="position()"/>
       	<xsl:variable name="attrName" select="translate(ancestor::table:table/table:table-header-rows/table:table-row[1]/table:table-cell[position()=$attrPos]/text:p,'ABCDEFGHIJKLMNOPQRSTUWVXYZ ','abcdefghijklmnopqrstuwvxyz_')"/>
		<xsl:choose>
        	<xsl:when test="$attrName!=''">
                <xsl:attribute name="{$attrName}">
                    <xsl:apply-templates select="child::*" mode="xml"/>
                </xsl:attribute>
        	</xsl:when>
			<!-- sinon les noms d'attributs sont construits sous la forme col(i) (avec i = numero de colonne -->
            <xsl:otherwise>
                <xsl:attribute name="{concat('col', string(position()))}">
                    <xsl:apply-templates select="child::*" mode="xml"/>
                </xsl:attribute>
            </xsl:otherwise>
        </xsl:choose>

	</xsl:template>

  	<xsl:template match="child::*" mode="xml" priority="-1">
    	<xsl:apply-templates select="node()" mode="xml"/>
	</xsl:template>

    <!-- Section "texte enrichi", export en mode 'spip' -->
    <!-- Paragraphe -->
  	<xsl:template match="text:p | text:h" mode="spip">
        <!-- ligne horizontal -->
        <xsl:if test="@text:style-name='Horizontal Line'">
	        <xsl:text>----------</xsl:text>
        </xsl:if>

<!-- RMQ: a revoir pour simplifier -->
        <xsl:variable name="styleName">
        	<xsl:value-of select="@text:style-name"/>
        </xsl:variable>
        <xsl:variable name="parentStyleName">
        	<xsl:value-of select="key('StyleForStyleName', $styleName)/@style:parent-style-name"/>
        </xsl:variable>
        <xsl:variable name="grandParentStyleName">
        	<xsl:value-of select="key('StyleForStyleName', $parentStyleName)/@style:parent-style-name"/>
        </xsl:variable>
        <xsl:variable name="isQuotations">
        	<xsl:value-of select="($styleName='Quotations') or ($parentStyleName='Quotations') or ($grandParentStyleName='Quotations')"/>
        </xsl:variable>

        <!-- style liste enumeree -->
        <xsl:variable name="listStyleName" select="key('StyleForStyleName', @text:style-name)/@style:list-style-name"/>

        <xsl:if test="$listStyleName!=''">
            <xsl:choose>
<!-- RMQ: revoir les niveaux de listes -->
            	<!-- liste avec numerotation -->
                <xsl:when test="key('ListStyleForStyleName', $listStyleName)[text:list-level-style-number/@style:num-format!='']">
			        <xsl:text>-# </xsl:text>
                </xsl:when>
            	<!-- liste a puces -->
                <xsl:otherwise>
			        <xsl:text>- </xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>

        <xsl:if test="$isQuotations">
            <xsl:text>&lt;quote&gt;</xsl:text>
        </xsl:if>
    	<xsl:apply-templates select="child::node()" mode="spip"/>
        <xsl:if test="$isQuotations">
            <xsl:text>&lt;/quote&gt;</xsl:text>
        </xsl:if>

       	<!-- Si l'on est pas dans une cellule de table, on saute a la ligne -->
        <xsl:if test="name(..)!='table:table-cell'">
    	    <xsl:text>&#10;</xsl:text>
        	<!-- Si l'on est pas dans une liste, on ajoute une ligne vide -->
	        <xsl:if test="not($listStyleName)">
		        <xsl:text>&#10;</xsl:text>
        	</xsl:if>
        </xsl:if>
	</xsl:template>

  	<xsl:template match="text:p/text()" mode="spip">
	  	<xsl:call-template name="textSPIP">
    		<xsl:with-param name="text" select="."/>
    		<xsl:with-param name="styleName" select="../@text:style-name"/>
	  	</xsl:call-template>
	</xsl:template>

  	<xsl:template match="text:h/text()" mode="spip">
        <xsl:text>{{{</xsl:text>
        <xsl:value-of select="."/>
        <xsl:text>}}}</xsl:text>
	</xsl:template>

  	<xsl:template match="text:s" mode="spip">
        <xsl:text></xsl:text>
	</xsl:template>

  	<xsl:template match="text:span" mode="spip">
    	<xsl:apply-templates select="child::node()" mode="spip"/>
	</xsl:template>

  	<xsl:template match="text:span/text()" mode="spip">
	  	<xsl:call-template name="textSPIP">
    		<xsl:with-param name="text" select="."/>
    		<xsl:with-param name="styleName" select="../@text:style-name"/>
	  	</xsl:call-template>
	</xsl:template>

  	<xsl:template match="text:line-break" mode="spip">
        <xsl:text>&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
	</xsl:template>

  	<xsl:template name="textSPIP">
    	<xsl:param name="text"/>
    	<xsl:param name="styleName"/>
<!-- RMQ: faire une fonction recursive pour remonter la cascade des styles au dela de 3 niveaux -->
        <xsl:variable name="parentStyleName">
        	<xsl:value-of select="key('StyleForStyleName', $styleName)/@style:parent-style-name"/>
        </xsl:variable>
        <xsl:variable name="grandParentStyleName">
        	<xsl:value-of select="key('StyleForStyleName', $parentStyleName)/@style:parent-style-name"/>
        </xsl:variable>
        <xsl:variable name="isBoldCaracteres">
        	<xsl:value-of select="key('isBoldCaracteresForStyleName', $styleName) or key('isBoldCaracteresForStyleName', $parentStyleName) or key('isBoldCaracteresForStyleName', $grandParentStyleName)"/>
        </xsl:variable>
        <xsl:variable name="isItalicCaracteres">
        	<xsl:value-of select="key('isItalicCaracteresForStyleName', $styleName) or key('isItalicCaracteresForStyleName', $parentStyleName) or key('isItalicCaracteresForStyleName', $grandParentStyleName)"/>
        </xsl:variable>

<!-- RMQ: voir comment traiter les notes de bas de page -->
        <xsl:choose>
            <xsl:when test="$isBoldCaracteres and $isItalicCaracteres">
                <xsl:text>{{ {</xsl:text>
                <xsl:value-of select="$text"/>
                <xsl:text>} }}</xsl:text>
            </xsl:when>
            <xsl:when test="$isBoldCaracteres">
                <xsl:text>{{</xsl:text>
                <xsl:value-of select="$text"/>
                <xsl:text>}}</xsl:text>
            </xsl:when>
            <xsl:when test="$isItalicCaracteres">
                <xsl:text>{</xsl:text>
                <xsl:value-of select="$text"/>
                <xsl:text>}</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$text"/>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>

    <!-- Table -->
  	<!-- xsl:template match="table:table" mode="spip">
        <xsl:text></xsl:text>
    	<xsl:apply-templates select="child::*" mode="spip"/>
	</xsl:template>
  	<xsl:template match="table:table-column" mode="spip">
        <xsl:text></xsl:text>
    	<xsl:apply-templates select="child::*" mode="spip"/>
	</xsl:template>
  	<xsl:template match="table:table-header-rows" mode="spip">
        <xsl:text></xsl:text>
    	<xsl:apply-templates select="child::*" mode="spip"/>
	</xsl:template -->
  	<xsl:template match="table:table-row" mode="spip">
        <xsl:text>|</xsl:text>
    	<xsl:apply-templates select="child::*" mode="spip"/>
        <xsl:text>&#10;</xsl:text>
	</xsl:template>

  	<xsl:template match="table:table-cell" mode="spip">
    	<xsl:apply-templates select="child::*" mode="spip"/>
        <xsl:text>|</xsl:text>
	</xsl:template>

    <!-- ligne horizontale sous forme d'une image -->
  	<xsl:template match="draw:image[starts-with(@draw:style-name, 'fr') and @text:anchor-type='as-char']" mode="spip">
        <xsl:text>----------</xsl:text>
	</xsl:template>

    <!-- lien hypertexte externe au site -->
  	<xsl:template match="text:a[(@xlink:type='simple') and (@xlink:href!='')]" mode="spip">
        <xsl:text>[</xsl:text>
        <xsl:value-of select="concat(concat(., '-&gt;'), @xlink:href)"/>
        <xsl:text>]</xsl:text>
	</xsl:template>

  	<xsl:template match="child::*" mode="spip" priority="-10">
    	<xsl:apply-templates select="child::*" mode="spip"/>
	</xsl:template>

    <!-- Section "texte enrichi",  export en mode 'html' -->
    <!-- RMQ: a faire -->

    <!-- Section "texte enrichi",  export en mode 'text' -->
    <!-- RMQ: a faire -->

    <!-- Section "texte enrichi",  export en mode 'rtf' -->
    <!-- RMQ: a faire -->

</xsl:transform>

